# Changelog

All notable changes to this project will be documented in this file.

## [0.5.1] - 2024-02-05

### Features

- Include the ratchet key in the Debug output of the Session

## [0.5.0] - 2023-10-06

### Features

- Add support for exporting an Account to a libolm pickle ([#111](https://github.com/matrix-org/vodozemac/pull/111))
- Add base64 decoding and encoding methods to the public interface ([#112](https://github.com/matrix-org/vodozemac/pull/112))


## [0.4.0] - 2023-05-31

### Bug Fixes

- Use the next key id from the libolm pickle instead of guessing

### Features

- Add a prettier display/debug implementation for Ed25519Signature
- Introduce an upgrade method to the InboundGroupSession struct
- Expose the version of vodozemac
- Make Debug representation of the public key types prettier
- Add a method to calculate the Session ID from a pre-key message
- [**breaking**] Return the created and discarded one-time keys when generating new ones ([#100](https://github.com/matrix-org/vodozemac/pull/100))
- [**breaking**] Return the fallback key which was removed when generating a new one
- Expose the build-time git commit hash and description as static vars
- Expose the Curve25519SecretKey type

### Refactor

- Rename the key_id field to next_key_id for clarity
- Use the matrix-pickle crate for libolm unpickling support

### Testing

- Ensure signing_key_verified is handled when upgrading.

## [0.3.0] - 2022-09-13

### Bug Fixes

- Accept a byteslice for the pickle key
- Hide the remove_one_time_key method
- Abort unpickling if we have too many one-time keys
- Use overflowing addition when incrementing key ids

### Documentation

- Fix some typos and improve the InboundGroupSession docs
- Clarify wording in OTK comment

### Features

- Add Debug and PartialEq implementations to MegolmMessage
- Add a bunch of missing Eq imlpementations
- Add TryFrom implementations for session keys
- Allow GroupSessions to be unpickled from libolm pickles
- Encode/decode bytes directly in Olm (no string wrapping)
- Encode/decode bytes directly in megolm (no string wrapping)
- Allow megolm messages to be cloned
- Add a method to check if two inbound group sessions are connected
- Add a method to compare two inbound group sessions
- Add support to not truncate MAC tags when encrypting messages
- Implement Display for the public key types
- Implement zeroize for the SessionKey

### Refactor

- Remove the encoded public key from the curve25519 types
- Remove the encoded public key methods
- Remove the encoded one-time keys method
- Create a LibolmEd25519Keypair struct
- Move the libolm RatchetPickle to a common module
- Move the libolm unpickling structs out of the method
- Improve the Debug implementation for SessionKeys
- Refrain from repeating method call.
- Group the session key methods correctly

<!-- generated by git-cliff -->
